# generated by datamodel-codegen:
#   filename:  system/ui/uiCustomization.json
#   timestamp: 2025-06-24T04:55:53+00:00

from __future__ import annotations

from typing import List, Optional

from pydantic import ConfigDict, Field
from typing_extensions import Annotated

from metadata.ingestion.models.custom_pydantic import BaseModel

from ...type import basic, entityHistory
from . import navigationItem, page


class UICustomization(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    id: basic.Uuid
    name: Annotated[
        basic.EntityName,
        Field(description='A unique name for the UI customization configuration.'),
    ]
    displayName: Annotated[
        Optional[str], Field(None, description='Name used for display purposes.')
    ]
    description: Annotated[
        Optional[basic.Markdown],
        Field(None, description='Description of the UI customization.'),
    ]
    pages: Annotated[
        List[page.Team], Field(description='List of Pages in the UI customization.')
    ]
    navigation: Annotated[
        Optional[List[navigationItem.NavigationItem]],
        Field(None, description='Site-wide navigation configuration.'),
    ]
    updatedAt: Optional[basic.Timestamp] = None
    updatedBy: Optional[str] = None
    version: Optional[entityHistory.EntityVersion] = None
    changeDescription: Optional[entityHistory.ChangeDescription] = None
    href: Optional[basic.Href] = None
